/*
 *			GPAC - MPEG-4 Systems C Development Kit
 *
 *			Copyright (c) Jean Le Feuvre 2000-2003 
 *					All rights reserved
 *
 *  This file is part of GPAC / wave audio render plugin
 *
 *  GPAC is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  GPAC is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *		
 */


#ifndef __CLOCK_DNA_H_
#define __CLOCK_DNA_H_

#ifdef __cplusplus
extern "C" {
#endif


#include <gpac/m4_avhw.h>

#define MAX_AUDIO_BUFFER	30

typedef struct 
{
	HWAVEOUT pWAV;
	WAVEHDR WaveHdr[MAX_AUDIO_BUFFER];
	WAVEFORMATEX format;

	u32 num_audio_buffer;
	u32 WaveBufferSize;
	u32 CurrentBuffer;

	M4Sema *sem;

	u32 vol, pan;
	u32 const_delay;

	Bool force_config;
	u32 cfg_num_buffers, cfg_num_buffer_per_sec;

	char *wav_buf;
} WAVContext;


#ifdef __cplusplus
}
#endif

#endif

